searchNodes=[{"doc":"Top level module providing Beamchmark.run/2 and Beamchmark.run_attached/2 API. Beamchmark measures EVM performance while it is running user Beamchmark.Scenario . Metrics being measured Scheduler Utilization At the moment, the main interest of Beamchmark is scheduler utilization which tells how much given scheduler was busy. Scheduler is busy when: Executing process code Executing linked-in driver or NIF code Executing BIFs, or any other runtime handling Garbage collecting Handling any other memory management Scheduler utilization is measured using Erlang's :scheduler module which uses :erlang.statistics/1 under the hood and it is represented as a floating point value between 0.0 and 1.0 and percent. Beamchmark measures following types of scheduler utilization: normal/cpu/io - average utilization of single scheduler of given type total normal/cpu/io - average utilization of all schedulers of given type. E.g total normal equals 1.0 when each of normal schedulers have been active all the time total - average utilization of all schedulers weighted - average utilization of all schedulers weighted against maximum amount of available CPU time For more information please refer to :erlang.statistics/1 (under :scheduler_wall_time ) or :scheduler.utilization/1 . Other Other metrics being measured: reductions - total reductions number context switches - total context switches number","ref":"Beamchmark.html","title":"Beamchmark","type":"module"},{"doc":"Runs scenario and benchmarks EVM performance. If compare? option equals true , invocation of this function will also compare new measurements with the last ones. Measurements will be compared only if they share the same scenario module, delay and duration.","ref":"Beamchmark.html#run/2","title":"Beamchmark.run/2","type":"function"},{"doc":"Executes Beamchmark.run/2 on a given node. This function can be used to measure performance of an already running node. The node which we are connecting to has to be a distributed node.","ref":"Beamchmark.html#run_attached/2","title":"Beamchmark.run_attached/2","type":"function"},{"doc":"Configuration for Beamchmark . name - name of the benchmark. It can be used by formatters. duration - time in seconds Beamchmark will be benchmarking EVM. Defaults to 60 seconds. cpu_interval - time in milliseconds Beamchmark will be benchmarking cpu usage. Defaults to 1000 milliseconds. Needs to be greater than or equal to interfere_timeout . memory_interval - time in milliseconds Beamchmark will be benchmarking memory usage. Defaults to 1000 milliseconds. Needs to be greater than or equal to interfere_timeout . delay - time in seconds Beamchmark will wait after running scenario and before starting benchmarking. Defaults to 0 seconds. formatters - list of formatters that will be applied to the result. By default contains only [Beamchmark.Formatters.Console] . compare? - boolean indicating whether formatters should compare results for given scenario with the previous one. Defaults to true. output_dir - directory where results of benchmarking will be saved. Defaults to &quot; beamchmark &quot; directory under location provided by System.tmp_dir!/0 .","ref":"Beamchmark.html#t:options_t/0","title":"Beamchmark.options_t/0","type":"type"},{"doc":"The module defines a behaviour that will be used to format and output Beamchmark.Suite . You can adopt this behaviour to implement custom formatters. The module contains helper functions for validating and applying formatters defined in configuration of Beamchmark.Suite .","ref":"Beamchmark.Formatter.html","title":"Beamchmark.Formatter","type":"behaviour"},{"doc":"Takes the suite and transforms it into some internal representation, that later on will be passed to write/2 .","ref":"Beamchmark.Formatter.html#c:format/2","title":"Beamchmark.Formatter.format/2","type":"callback"},{"doc":"Works like format/2 , but can provide additional information by comparing the latest suite with the previous one (passed as the second argument).","ref":"Beamchmark.Formatter.html#c:format/3","title":"Beamchmark.Formatter.format/3","type":"callback"},{"doc":"Takes the suite and uses its formatters to output it. If the suite was configured with compare? flag enabled, the previous suite will be also provided to the formatters.","ref":"Beamchmark.Formatter.html#output/1","title":"Beamchmark.Formatter.output/1","type":"function"},{"doc":"Takes the return value of format/1 or format/2 and outputs it in a convenient form (stdout, file, UI...).","ref":"Beamchmark.Formatter.html#c:write/2","title":"Beamchmark.Formatter.write/2","type":"callback"},{"doc":"Options given to formatters (defined by formatters authors).","ref":"Beamchmark.Formatter.html#t:options_t/0","title":"Beamchmark.Formatter.options_t/0","type":"type"},{"doc":"Represents a module implementing Beamchmark.Formatter behaviour.","ref":"Beamchmark.Formatter.html#t:t/0","title":"Beamchmark.Formatter.t/0","type":"type"},{"doc":"The module contains helper math types and utility functions.","ref":"Beamchmark.Math.html","title":"Beamchmark.Math","type":"module"},{"doc":"","ref":"Beamchmark.Math.html#percent_diff/2","title":"Beamchmark.Math.percent_diff/2","type":"function"},{"doc":"Represents a percent difference. This can be either percent_t/0 or :nan when trying to compare value with 0.","ref":"Beamchmark.Math.html#t:percent_diff_t/0","title":"Beamchmark.Math.percent_diff_t/0","type":"type"},{"doc":"Represents a percent.","ref":"Beamchmark.Math.html#t:percent_t/0","title":"Beamchmark.Math.percent_t/0","type":"type"},{"doc":"Scenario to run during benchmarking. Defines a behaviour that needs to be adopted by benchmarked modules. Beamchmark will call the implementation of run/0 in a new process, shutting it down once it completes all measurements. The implementation should run for a longer period of time (possibly infinite) than measurements, so that the EVM isn't benchmarked while it's idle. For the same reason, it is recommended to raise immediately in case the implementation fails.","ref":"Beamchmark.Scenario.html","title":"Beamchmark.Scenario","type":"behaviour"},{"doc":"The function that will be called during benchmarking.","ref":"Beamchmark.Scenario.html#c:run/0","title":"Beamchmark.Scenario.run/0","type":"callback"},{"doc":"Represents a module implementing Beamchmark.Scenario behaviour.","ref":"Beamchmark.Scenario.html#t:t/0","title":"Beamchmark.Scenario.t/0","type":"type"},{"doc":"The module defines a struct representing a single run of benchmark. It is also responsible for running the benchmark and saving/loading the results. The results are serialized and stored in output_dir / scenario name / delay_duration directory, where scenario name is the name of module implementing scenario (without separating dots) and output_dir , delay , duration are fetched from the suite's configuration.","ref":"Beamchmark.Suite.html","title":"Beamchmark.Suite","type":"module"},{"doc":"","ref":"Beamchmark.Suite.html#init/1","title":"Beamchmark.Suite.init/1","type":"function"},{"doc":"","ref":"Beamchmark.Suite.html#init/2","title":"Beamchmark.Suite.init/2","type":"function"},{"doc":"","ref":"Beamchmark.Suite.html#run/1","title":"Beamchmark.Suite.run/1","type":"function"},{"doc":"","ref":"Beamchmark.Suite.html#save/1","title":"Beamchmark.Suite.save/1","type":"function"},{"doc":"","ref":"Beamchmark.Suite.html#try_load_base/1","title":"Beamchmark.Suite.try_load_base/1","type":"function"},{"doc":"","ref":"Beamchmark.Suite.html#t:t/0","title":"Beamchmark.Suite.t/0","type":"type"},{"doc":"The module defines utility functions for Beamchmark.","ref":"Beamchmark.Utils.html","title":"Beamchmark.Utils","type":"module"},{"doc":"","ref":"Beamchmark.Utils.html#get_os_name/0","title":"Beamchmark.Utils.get_os_name/0","type":"function"},{"doc":"The module formats Beamchmark.Suite and outputs it using Mix.shell/0 .","ref":"Beamchmark.Formatters.Console.html","title":"Beamchmark.Formatters.Console","type":"module"},{"doc":"The module formats Beamchmark.Suite and outputs it to an HTML file.","ref":"Beamchmark.Formatters.HTML.html","title":"Beamchmark.Formatters.HTML","type":"module"},{"doc":"Configuration for Beamchmark.Formatters.HTML . output_path – path to the file, where the report will be saved. Defaults to &quot;index.html&quot; . auto_open? – if true , opens the report in system's default browser. Defaults to true . inline_assets? – if true , pastes contents of .css and .js assets directly into HTML. Defaults to false .","ref":"Beamchmark.Formatters.HTML.html#t:options_t/0","title":"Beamchmark.Formatters.HTML.options_t/0","type":"type"},{"doc":"The module provides functions common for multiple formatters.","ref":"Beamchmark.Formatters.Utils.html","title":"Beamchmark.Formatters.Utils","type":"module"},{"doc":"Takes memory in bytes and returns it as human-readable string.","ref":"Beamchmark.Formatters.Utils.html#format_memory/2","title":"Beamchmark.Formatters.Utils.format_memory/2","type":"function"},{"doc":"This module contains the CPU benchmarking task. Measurements are performed using :cpu_sup.util/1 Currently (according to docs), as busy processor states we identify: user nice_user (low priority use mode) kernel","ref":"Beamchmark.Suite.CPU.CpuTask.html","title":"Beamchmark.Suite.CPU.CpuTask","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. arg is passed as the argument to Task.start_link/1 in the :start field of the spec. For more information, see the Supervisor module, the Supervisor.child_spec/2 function and the Supervisor.child_spec/0 type.","ref":"Beamchmark.Suite.CPU.CpuTask.html#child_spec/1","title":"Beamchmark.Suite.CPU.CpuTask.child_spec/1","type":"function"},{"doc":"","ref":"Beamchmark.Suite.CPU.CpuTask.html#start_link/2","title":"Beamchmark.Suite.CPU.CpuTask.start_link/2","type":"function"},{"doc":"The module defines a structure used to configure Beamchmark.Suite . For more information about customizing Beamchmark, refer to Beamchmark.options_t/0 .","ref":"Beamchmark.Suite.Configuration.html","title":"Beamchmark.Suite.Configuration","type":"module"},{"doc":"","ref":"Beamchmark.Suite.Configuration.html#get_configuration/2","title":"Beamchmark.Suite.Configuration.get_configuration/2","type":"function"},{"doc":"","ref":"Beamchmark.Suite.Configuration.html#t:t/0","title":"Beamchmark.Suite.Configuration.t/0","type":"type"},{"doc":"The module is responsible for gathering BEAM statistics during benchmarking.","ref":"Beamchmark.Suite.Measurements.html","title":"Beamchmark.Suite.Measurements","type":"module"},{"doc":"","ref":"Beamchmark.Suite.Measurements.html#diff/2","title":"Beamchmark.Suite.Measurements.diff/2","type":"function"},{"doc":"","ref":"Beamchmark.Suite.Measurements.html#gather/3","title":"Beamchmark.Suite.Measurements.gather/3","type":"function"},{"doc":"","ref":"Beamchmark.Suite.Measurements.html#t:context_switches_t/0","title":"Beamchmark.Suite.Measurements.context_switches_t/0","type":"type"},{"doc":"","ref":"Beamchmark.Suite.Measurements.html#t:reductions_t/0","title":"Beamchmark.Suite.Measurements.reductions_t/0","type":"type"},{"doc":"","ref":"Beamchmark.Suite.Measurements.html#t:t/0","title":"Beamchmark.Suite.Measurements.t/0","type":"type"},{"doc":"Module representing statistics about cpu usage. Method of measuring: Take a snapshot of cpu usage every cpu_interval milliseconds Calculate the average cpu usage of processor (combining each core usage) At the end combine the results and calculate the average Warning! This module can give unstable cpu usage values when measuring a short time because of a high cpu volatility. TODO Can be improved by taking average of 5-10 values for each snapshot","ref":"Beamchmark.Suite.Measurements.CpuInfo.html","title":"Beamchmark.Suite.Measurements.CpuInfo","type":"module"},{"doc":"","ref":"Beamchmark.Suite.Measurements.CpuInfo.html#diff/2","title":"Beamchmark.Suite.Measurements.CpuInfo.diff/2","type":"function"},{"doc":"Converts list of cpu_snapshot_t to Elixir.Beamchmark.Suite.Measurements.CpuInfo.t() By calculating the average","ref":"Beamchmark.Suite.Measurements.CpuInfo.html#from_cpu_snapshots/1","title":"Beamchmark.Suite.Measurements.CpuInfo.from_cpu_snapshots/1","type":"function"},{"doc":"All information gathered via single snapshot + processor average","ref":"Beamchmark.Suite.Measurements.CpuInfo.html#t:cpu_snapshot_t/0","title":"Beamchmark.Suite.Measurements.CpuInfo.cpu_snapshot_t/0","type":"type"},{"doc":"All information gathered via all snapshots all_average is average from all snapshots","ref":"Beamchmark.Suite.Measurements.CpuInfo.html#t:t/0","title":"Beamchmark.Suite.Measurements.CpuInfo.t/0","type":"type"},{"doc":"Module representing statistics about memory usage.","ref":"Beamchmark.Suite.Measurements.MemoryInfo.html","title":"Beamchmark.Suite.Measurements.MemoryInfo","type":"module"},{"doc":"","ref":"Beamchmark.Suite.Measurements.MemoryInfo.html#diff/2","title":"Beamchmark.Suite.Measurements.MemoryInfo.diff/2","type":"function"},{"doc":"","ref":"Beamchmark.Suite.Measurements.MemoryInfo.html#from_memory_snapshots/1","title":"Beamchmark.Suite.Measurements.MemoryInfo.from_memory_snapshots/1","type":"function"},{"doc":"","ref":"Beamchmark.Suite.Measurements.MemoryInfo.html#t:bytes_t/0","title":"Beamchmark.Suite.Measurements.MemoryInfo.bytes_t/0","type":"type"},{"doc":"","ref":"Beamchmark.Suite.Measurements.MemoryInfo.html#t:memory_snapshot_t/0","title":"Beamchmark.Suite.Measurements.MemoryInfo.memory_snapshot_t/0","type":"type"},{"doc":"","ref":"Beamchmark.Suite.Measurements.MemoryInfo.html#t:t/0","title":"Beamchmark.Suite.Measurements.MemoryInfo.t/0","type":"type"},{"doc":"Module representing different statistics about scheduler usage.","ref":"Beamchmark.Suite.Measurements.SchedulerInfo.html","title":"Beamchmark.Suite.Measurements.SchedulerInfo","type":"module"},{"doc":"","ref":"Beamchmark.Suite.Measurements.SchedulerInfo.html#diff/2","title":"Beamchmark.Suite.Measurements.SchedulerInfo.diff/2","type":"function"},{"doc":"","ref":"Beamchmark.Suite.Measurements.SchedulerInfo.html#from_sched_util_result/1","title":"Beamchmark.Suite.Measurements.SchedulerInfo.from_sched_util_result/1","type":"function"},{"doc":"","ref":"Beamchmark.Suite.Measurements.SchedulerInfo.html#t:sched_usage_t/0","title":"Beamchmark.Suite.Measurements.SchedulerInfo.sched_usage_t/0","type":"type"},{"doc":"","ref":"Beamchmark.Suite.Measurements.SchedulerInfo.html#t:t/0","title":"Beamchmark.Suite.Measurements.SchedulerInfo.t/0","type":"type"},{"doc":"","ref":"Beamchmark.Suite.Measurements.SchedulerInfo.html#t:total_sched_usage_t/0","title":"Beamchmark.Suite.Measurements.SchedulerInfo.total_sched_usage_t/0","type":"type"},{"doc":"","ref":"Beamchmark.Suite.Measurements.SchedulerInfo.html#t:weighted_sched_usage_t/0","title":"Beamchmark.Suite.Measurements.SchedulerInfo.weighted_sched_usage_t/0","type":"type"},{"doc":"This module contains the memory benchmarking task. Measurements are performed using :erlang.memory/0","ref":"Beamchmark.Suite.Memory.MemoryTask.html","title":"Beamchmark.Suite.Memory.MemoryTask","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. arg is passed as the argument to Task.start_link/1 in the :start field of the spec. For more information, see the Supervisor module, the Supervisor.child_spec/2 function and the Supervisor.child_spec/0 type.","ref":"Beamchmark.Suite.Memory.MemoryTask.html#child_spec/1","title":"Beamchmark.Suite.Memory.MemoryTask.child_spec/1","type":"function"},{"doc":"","ref":"Beamchmark.Suite.Memory.MemoryTask.html#start_link/2","title":"Beamchmark.Suite.Memory.MemoryTask.start_link/2","type":"function"},{"doc":"The module defines a struct containing various information about system that is used for benchmarking.","ref":"Beamchmark.Suite.SystemInfo.html","title":"Beamchmark.Suite.SystemInfo","type":"module"},{"doc":"","ref":"Beamchmark.Suite.SystemInfo.html#init/0","title":"Beamchmark.Suite.SystemInfo.init/0","type":"function"},{"doc":"","ref":"Beamchmark.Suite.SystemInfo.html#t:t/0","title":"Beamchmark.Suite.SystemInfo.t/0","type":"type"},{"doc":"Tool for measuring EVM performance. At the moment, the main interest of Beamchmark is scheduler utilization, reductions and the number of context switches. For more information please refer to API docs. Currently, Beamchmark is supported on macOS, Linux and partially on Windows.","ref":"readme.html","title":"Beamchmark","type":"extras"},{"doc":"Beamchmark should be used when you want to measure BEAM performance while it is running your application. Benchee should be used when you want to benchmark specific function from your code base. In particular, Benchee will inform you how long your function is executing, while Beamchmark will inform you how busy BEAM is.","ref":"readme.html#beamchmark-and-benchee","title":"Beamchmark - Beamchmark and Benchee","type":"extras"},{"doc":"The package can be installed by adding beamchmark to your list of dependencies in mix.exs : def deps do [ { :beamchmark , &quot;~&gt; 1.4.0&quot; } ] end","ref":"readme.html#installation","title":"Beamchmark - Installation","type":"extras"},{"doc":"Running an application using Beamchmark.Scenario You create a test scenario by adopting Beamchmark.Scenario behaviour in a module. It has to implement run() function, which will execute for benchmarking. The examples of using Scenario are located in the examples directory. To run one of them, simply use the following command: mix run examples/&lt;example_name&gt;.exs Running Beamchmark in an attached mode If you want to measure the performance of an already running BEAM you can run Beamchmark in an attached mode. However, it is required that the node on which your application is running is a distributed node and has Beamchmark added to its dependencies. To run an example of Beamchmark in attached mode first start the node, which performance will be measured: cd examples/attached mix deps.get elixir --sname counter@localhost -S mix run start_counter.exs The node will be visible under counter@localhost name. Now in another terminal you can start the benchmark: epmd -daemon mix run examples/attached/run_attached.exs","ref":"readme.html#usage","title":"Beamchmark - Usage","type":"extras"},{"doc":"You can output benchmark results with Beamchmark's built-in formatters or implement a custom one. Formatters can also compare new results with the previous ones, given they share the same scenario module and were configured to run for the same amount of time. Currently, you can output Beamchmark reports in the following ways: Beamchmark.Formatters.Console This is the default formatter, it will print the report on standard output. ================ SYSTEM INFO ================ Elixir version: 1.13.4 OTP version: 24 OS: macOS Memory: 16 GB System arch: x86_64-apple-darwin21.3.0 NIF version: 2.16 Cores: 8 ================ CONFIGURATION ================ Delay: 5s Duration: 15s ================ MEASUREMENTS ================ Normal schedulers -------------------- 1 0.7462382700312585 74.6% 2 0.7552131238891551 75.5% 3 0.7080346117265083 70.8% 4 0.6840002812013201 68.4% 5 0.7357487054135822 73.6% 6 0.7889711402496832 78.9% 7 0.7053186570052465 70.5% 8 0.495807853995791 49.6% Total: 0.7024165804390681 70.2% CPU schedulers -------------------- 9 0.39409732340500314 39.4% 10 0.5194739765841625 51.9% 11 0.45208160433332006 45.2% 12 0.33614215325750824 33.6% 13 0.05474778835410803 5.5% 14 0.31687236471324787 31.7% 15 0.06046101946449905 6.0% 16 0.0 0.0% Total: 0.2667345287639811 26.7% IO schedulers -------------------- 17 0.0 0.0% 18 0.0 0.0% 19 0.0 0.0% 20 0.0 0.0% 21 0.0 0.0% 22 0.0 0.0% 23 0.0 0.0% 24 0.0 0.0% 25 2.7705124922689514e-4 0.0% 26 0.0 0.0% Total: 2.7705124922689516e-5 0.0% Weighted -------------------- 0.9692071705951804 96.9% Reductions -------------------- 2847054520 Context Switches -------------------- 717845 CPU Usage Average -------------------- 51.2% CPU Usage Per Core -------------------- Core: 0 -&gt; 99.81 % Core: 1 -&gt; 2.84 % Core: 2 -&gt; 99.81 % Core: 3 -&gt; 2.57 % Core: 4 -&gt; 99.82 % Core: 5 -&gt; 2.23 % Core: 6 -&gt; 99.88 % Core: 7 -&gt; 2.6 % Memory usage -------------------- 3.56 GB ================ NEW MEASUREMENTS ================ Normal schedulers -------------------- 1 0.7391849466705548 73.9% -0.007053323360703745 -0.9383378016085686% 2 0.6451374210660318 64.5% -0.11007570282312329 -14.569536423841058% 3 0.612116497924041 61.2% -0.09591811380246729 -13.559322033898297% 4 0.7119528248221814 71.2% 0.027952543620861303 4.093567251461991% 5 0.7175675964576803 71.8% -0.01818110895590186 -2.4456521739130324% 6 0.667647106911744 66.8% -0.12132403333793917 -15.335868187579223% 7 0.7588791891435591 75.9% 0.05356053213831258 7.659574468085111% 8 0.7007975884343178 70.1% 0.2049897344385268 41.330645161290306% Total: 0.6941603964287638 69.4% -0.008256184010304257 -1.139601139601126% CPU schedulers -------------------- 9 0.40317586539492 40.3% 0.009078541989916866 2.284263959390856% 10 0.0658197960010861 6.6% -0.4536541805830764 -87.28323699421965% 11 0.207488920931131 20.7% -0.24459268340218907 -54.20353982300885% 12 0.4070941615062336 40.7% 0.07095200824872538 21.130952380952394% 13 0.5912324517586194 59.1% 0.5364846634045114 974.5454545454545% 14 4.213003273973723e-8 0.0% -0.3168723225832151 -100% 15 0.5185116282961778 51.9% 0.45805060883167875 765.0% 16 0.014049861167737257 1.4% 0.014049861167737257 nan Total: 0.27592159089824225 27.6% 0.009187062134261126 3.37078651685394% IO schedulers -------------------- 17 0.0 0.0% 0.0 0% 18 0.0 0.0% 0.0 0% 19 0.0 0.0% 0.0 0% 20 0.0 0.0% 0.0 0% 21 0.0 0.0% 0.0 0% 22 0.0 0.0% 0.0 0% 23 0.0 0.0% 0.0 0% 24 0.0 0.0% 0.0 0% 25 0.0 0.0% -2.7705124922689514e-4 0% 26 2.2108785953999204e-4 0.0% 2.2108785953999204e-4 0% Total: 2.2108785953999205e-5 0.0% -5.596338968690311e-6 0% Weighted -------------------- 0.9700717546422247 97.0% 8.6458404704437e-4 0.10319917440659765% Reductions -------------------- 2621243405 -225811115 -7.931394127289138% Context Switches -------------------- 666449 -51396 -7.159762901462017% CPU Usage Average -------------------- 51.88% 0.68% 1.34% CPU Usage Per Core -------------------- Core 0 -&gt; 99.74% -0.07 -0.07 % Core 1 -&gt; 4.35% 1.51 53.17 % Core 2 -&gt; 99.83% 0.01 0.01 % Core 3 -&gt; 3.96% 1.39 53.96 % Core 4 -&gt; 99.82% 0.01 0.01 % Core 5 -&gt; 3.75% 1.52 68.44 % Core 6 -&gt; 99.76% -0.12 -0.12 % Core 7 -&gt; 3.83% 1.22 46.91 % Memory usage -------------------- 3.58 GB 21.96 MB 0.6% Beamchmark.Formatters.HTML The HTML formatter will save the report to an HTML file. Custom formatters You can implement your custom formatters by overriding Beamchmark.Formatter behaviour.","ref":"readme.html#formatters","title":"Beamchmark - Formatters","type":"extras"},{"doc":"Copyright 2021, Software Mansion Licensed under the Apache License, Version 2.0","ref":"readme.html#copyright-and-license","title":"Beamchmark - Copyright and License","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2020 Software Mansion Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]